diff --git a/ldap/servers/plugins/replication/repl5_replica_config.c b/ldap/servers/plugins/replication/repl5_replica_config.c
index ed6b29e..e05418b 100644
--- a/ldap/servers/plugins/replication/repl5_replica_config.c
+++ b/ldap/servers/plugins/replication/repl5_replica_config.c
@@ -375,6 +375,10 @@ replica_config_modify(Slapi_PBlock *pb,
         */
         char *new_repl_id = NULL;
         char *new_repl_type = NULL;
+        /* we also need to handle the change of repl_flags and enable or disable 
+         * the changelog
+         */
+        char *new_repl_flag = NULL;
 
         if (*returncode != LDAP_SUCCESS)
             break;
@@ -619,6 +623,10 @@ replica_config_modify(Slapi_PBlock *pb,
             slapi_ch_free_string(&new_repl_type);
             agmtlist_notify_all(pb);
         }
+        if (new_repl_flag) {
+            *returncode = replica_config_change_flags(r, new_repl_flag, errortext, apply_mods);
+            slapi_ch_free_string(&new_repl_flag);
+        }
     }
 
 done:
@@ -768,6 +776,7 @@ replica_config_delete(Slapi_PBlock *pb __attribute__((unused)),
 
     if (mtnode_ext->replica) {
         /* remove object from the hash */
+        Object *r_obj = mtnode_ext->replica;
         r = (Replica *)object_get_data(mtnode_ext->replica);
         mtnode_ext->replica = NULL;  /* moving it before deleting the CL because
                                       * deletion can take some time giving the opportunity
@@ -779,8 +788,9 @@ replica_config_delete(Slapi_PBlock *pb __attribute__((unused)),
                                                            "The changelog for replica %s is no longer valid since "
                                                            "the replica config is being deleted.  Removing the changelog.\n",
                       slapi_sdn_get_dn(replica_get_root(r)));
-        cl5DeleteDBSync(r);
+        cldb_RemoveReplicaDB(r);
         replica_delete_by_name(replica_get_name(r));
+        object_release(r_obj);
     }
 
     PR_Unlock(s_configLock);
@@ -973,7 +983,7 @@ replica_config_change_type_and_id(Replica *r, const char *new_type, const char *
                     replica_reset_csn_pl(r);
                 }
                 ruv_delete_replica(ruv, oldrid);
-                cl5CleanRUV(oldrid);
+                cl5CleanRUV(oldrid, r);
                 replica_set_csn_assigned(r);
             }
             object_release(ruv_obj);
@@ -1034,6 +1044,13 @@ replica_config_change_flags(Replica *r, const char *new_flags, char *returntext 
 
         flags = atol(new_flags);
 
+        if (replica_is_flag_set(r, REPLICA_LOG_CHANGES) && !(flags&REPLICA_LOG_CHANGES)) {
+            /* the replica no longer maintains a changelog, reset */
+           cldb_UnSetReplicaDB(r, NULL);
+        } else if (!replica_is_flag_set(r, REPLICA_LOG_CHANGES) && (flags&REPLICA_LOG_CHANGES)) {
+            /* the replica starts to maintains a changelog, set */
+            cldb_SetReplicaDB(r, NULL);
+        }
         replica_replace_flags(r, flags);
     }
 
@@ -1153,7 +1170,6 @@ static int
 replica_execute_cl2ldif_task(Replica *replica, char *returntext)
 {
     int rc;
-    Replica *rlist[2];
     char fName[MAXPATHLEN];
     char *clDir = NULL;
 
@@ -1167,7 +1183,8 @@ replica_execute_cl2ldif_task(Replica *replica, char *returntext)
 
     /* file is stored in the changelog directory and is named
        <replica name>.ldif */
-    clDir = cl5GetDir();
+    Slapi_Backend *be = slapi_be_select(replica_get_root(replica));
+    clDir = cl5GetLdifDir(be);
     if (NULL == clDir) {
         rc = LDAP_OPERATIONS_ERROR;
         goto bail;
@@ -1177,15 +1194,12 @@ replica_execute_cl2ldif_task(Replica *replica, char *returntext)
         rc = LDAP_OPERATIONS_ERROR;
         goto bail;
     }
-    rlist[0] = replica;
-    rlist[1] = NULL;
 
-
-    PR_snprintf(fName, MAXPATHLEN, "%s/%s.ldif", clDir, replica_get_name(replica));
+    PR_snprintf(fName, MAXPATHLEN, "%s/%s_cl.ldif", clDir, replica_get_name(replica));
     slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name,
                   "replica_execute_cl2ldif_task - Beginning changelog export of replica \"%s\"\n",
                   replica_get_name(replica));
-    rc = cl5ExportLDIF(fName, rlist);
+    rc = cl5ExportLDIF(fName, replica);
     if (rc == CL5_SUCCESS) {
         slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name,
                       "replica_execute_cl2ldif_task - Finished changelog export of replica \"%s\"\n",
@@ -1210,7 +1224,6 @@ static int
 replica_execute_ldif2cl_task(Replica *replica, char *returntext)
 {
     int rc, imprc = 0;
-    Replica *rlist[2];
     char fName[MAXPATHLEN];
     char *clDir = NULL;
     changelog5Config config;
@@ -1225,7 +1238,8 @@ replica_execute_ldif2cl_task(Replica *replica, char *returntext)
 
     /* file is stored in the changelog directory and is named
        <replica name>.ldif */
-    clDir = cl5GetDir();
+    Slapi_Backend *be = slapi_be_select(replica_get_root(replica));
+    clDir = cl5GetLdifDir(be);
     if (NULL == clDir) {
         rc = LDAP_OPERATIONS_ERROR;
         goto bail;
@@ -1235,8 +1249,6 @@ replica_execute_ldif2cl_task(Replica *replica, char *returntext)
         rc = LDAP_OPERATIONS_ERROR;
         goto bail;
     }
-    rlist[0] = replica;
-    rlist[1] = NULL;
 
     PR_snprintf(fName, MAXPATHLEN, "%s/%s.ldif", clDir, replica_get_name(replica));
 
@@ -1254,7 +1266,7 @@ replica_execute_ldif2cl_task(Replica *replica, char *returntext)
     slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name,
                   "replica_execute_ldif2cl_task -  Beginning changelog import of replica \"%s\"\n",
                   replica_get_name(replica));
-    imprc = cl5ImportLDIF(clDir, fName, rlist);
+    imprc = cl5ImportLDIF(clDir, fName, replica);
     if (CL5_SUCCESS == imprc) {
         slapi_log_err(SLAPI_LOG_INFO, repl_plugin_name,
                       "replica_execute_ldif2cl_task - Finished changelog import of replica \"%s\"\n",
@@ -1270,7 +1282,7 @@ replica_execute_ldif2cl_task(Replica *replica, char *returntext)
     }
     changelog5_read_config(&config);
     /* restart changelog */
-    rc = cl5Open(config.dir, &config.dbconfig);
+    rc = cl5Open();
     if (CL5_SUCCESS == rc) {
         rc = LDAP_SUCCESS;
     } else {
@@ -1363,7 +1375,7 @@ replica_execute_cleanruv_task(Replica *replica, ReplicaId rid, char *returntext 
     /*
      *  Clean the changelog RUV's
      */
-    cl5CleanRUV(rid);
+    cl5CleanRUV(rid, replica);
 
     /*
      * Now purge the changelog.  The purging thread will free the purge_data
@@ -1371,8 +1383,7 @@ replica_execute_cleanruv_task(Replica *replica, ReplicaId rid, char *returntext 
     purge_data = (cleanruv_purge_data *)slapi_ch_calloc(1, sizeof(cleanruv_purge_data));
     purge_data->cleaned_rid = rid;
     purge_data->suffix_sdn = replica_get_root(replica);
-    purge_data->replName = (char *)replica_get_name(replica);
-    purge_data->replGen = replica_get_generation(replica);
+    purge_data->replica = replica;
     trigger_cl_purging(purge_data);
 
     if (rc != RUV_SUCCESS) {
diff --git a/ldap/servers/plugins/replication/repl_extop.c b/ldap/servers/plugins/replication/repl_extop.c
index 14c8e0b..3f94951 100644
--- a/ldap/servers/plugins/replication/repl_extop.c
+++ b/ldap/servers/plugins/replication/repl_extop.c
@@ -1159,11 +1159,13 @@ multimaster_extop_EndNSDS50ReplicationRequest(Slapi_PBlock *pb)
                    The best solution I think, would be to "fake" on the supplier
                    an entry that corresponds to the ruv sent to the consumer and then
                    send it as part of the data */
-
+/*
                 if (cl5GetState() == CL5_STATE_OPEN) {
                     cl5DeleteDBSync(connext->replica_acquired);
                 }
-
+                no longer needed, the cl was recreated when replication was reenabled
+                at the end of bulk import
+*/
                 replica_set_ruv(r, connext->supplier_ruv);
                 connext->supplier_ruv = NULL;
 
@@ -1171,7 +1173,8 @@ multimaster_extop_EndNSDS50ReplicationRequest(Slapi_PBlock *pb)
                    smallest csn in the new ruv, so that this replica ca supply
                    other servers.
                 */
-                if (cl5GetState() == CL5_STATE_OPEN) {
+                if (replica_is_flag_set(r, REPLICA_LOG_CHANGES) &&
+                    cl5GetState() == CL5_STATE_OPEN) {
                     replica_log_ruv_elements(r);
                 }
 
diff --git a/ldap/servers/slapd/back-ldbm/archive.c b/ldap/servers/slapd/back-ldbm/archive.c
index 4eb0eb5..5a70ab1 100644
--- a/ldap/servers/slapd/back-ldbm/archive.c
+++ b/ldap/servers/slapd/back-ldbm/archive.c
@@ -412,28 +412,9 @@ ldbm_back_ldbm2archive(Slapi_PBlock *pb)
         }
     }
 
-    return_value = plugin_call_plugins(pb, SLAPI_PLUGIN_BE_PRE_BACKUP_FN);
-    if (return_value) {
-        slapi_log_err(SLAPI_LOG_BACKLDBM,
-                      "ldbm_back_ldbm2archive", "pre-backup-plugin failed (%d).\n", return_value);
-        if (is_slapd_running() && run_from_cmdline) {
-            slapi_log_err(SLAPI_LOG_ERR,
-                          "ldbm_back_ldbm2archive", "Standalone db2bak is not supported when a "
-                                                    "multimaster replication enabled server is "
-                                                    "coexisting.\nPlease use db2bak.pl, instead.\n");
-            goto err;
-        }
-    }
-
     /* tell it to archive */
     return_value = dblayer_backup(li, directory, task);
 
-    return_value = plugin_call_plugins(pb, SLAPI_PLUGIN_BE_POST_BACKUP_FN);
-    if (return_value) {
-        slapi_log_err(SLAPI_LOG_BACKLDBM,
-                      "ldbm_back_ldbm2archive", "post-backup-plugin failed (%d).\n", return_value);
-    }
-
     if (!run_from_cmdline) {
         ldbm_instance *inst;
         Object *inst_obj;
diff --git a/ldap/servers/slapd/back-ldbm/back-ldbm.h b/ldap/servers/slapd/back-ldbm/back-ldbm.h
index 9d78ad7..b588e2d 100644
--- a/ldap/servers/slapd/back-ldbm/back-ldbm.h
+++ b/ldap/servers/slapd/back-ldbm/back-ldbm.h
@@ -734,6 +734,7 @@ typedef struct ldbm_instance
     PRLock *inst_handle_list_mutex;
 
     DB *inst_id2entry; /* id2entry for this instance. */
+    DB *inst_changelog; /* changelog for this instance. */
 
     perfctrs_private inst_perf_private; /* Private data for the performance counters specific to this instance */
     attrcrypt_state_private *inst_attrcrypt_state_private;
